%
% Copyright (c) 2011, Kai Guo, Prakash Ishwar, and Janusz Konrad. All
% rights reserved.
%
% Redistribution and use in source and binary forms, with or without
% modification, are permitted provided that the following conditions are
% met:
%
% 1) Redistributions of source code must retain the above copyright
%    notice, this list of conditions and the following disclaimer.
%
% 2) Redistributions in binary form must reproduce the above copyright
%    notice, this list of conditions and the following disclaimer in the
%    documentation and/or other materials provided with the distribution.
%
% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
% "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
% LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
% A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
% HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
% SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
% LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
% DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
% THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
% (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
% OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
%

% silhouette-feature:
% f=[x,y,dE,dW,dS,dN,dSE,dNW,dSW,dNE,dt-,dt+,t];

function [CM,MU]=cov_mask_3D_feature_single(Mask)

seq=double(Mask);
[h,v,c,p]=size(seq);

[x,y,t]=meshgrid(0:1:v-1,0:1:h-1,0:1:c-1);

x=reshape(x,[],1);
y=reshape(y,[],1);
t=reshape(t,[],1);

F=[x,y];

for u=1:p-1
    F(:,u+2)=reshape(seq(:,:,:,u),[],1);
end

F=[F,t,reshape(seq(:,:,:,p),[],1)];
% 
% selectively choose foreground pixels to compute covariance matrix
% 
F(find(F(:,end)==0),:)=[];
F=F(:,1:end-1);
[num,temp]=size(F);     

W=[ones(num,10)*sqrt(num),ones(num1,3)];
F_norm=F./W;
CM=cov(F_norm);
MU=mean(F_norm);

%%%%%%%%
